import React, {Component} from 'react';
import PropTypes from 'prop-types';

class FB extends Component{
  static get style(){
    return {
      width: '264px',
      height: '40px',
      display: 'inline-block',
      position: 'relative'
    };
  }

  static get invisible(){
    return {
      position: 'absolute',
      left: 0,
      top: 0,
      width: '264px',
      height: '40px',
      zIndex: 2000
    };
  }

  static set appId(appId){
    (function (d, s, id) {
      const element = document.createElement('div');
      element.id = 'fb-root';
      document.body.appendChild(element);
      const fjs = d.getElementsByTagName(s)[0];
      if (d.getElementById(id)) return;
      const js = d.createElement(s);
      js.id = id;
      js.src = `https://connect.facebook.net/en_US/sdk.js#xfbml=1&version=v3.1&appId=${appId}&autoLogAppEvents=1`;
      fjs.parentNode.insertBefore(js, fjs);
    }(window.document, 'script', 'facebook-jssdk'));

    FB.injected = true;
  }

  render(){
    const propStyle = this.props.style;
    const finalStyle = Object.assign(FB.style, propStyle);

    this.click = e => {
      if(this.props.onClick){
        e.preventDefault();
        this.props.onClick();
      }
    }

    this.click = this.click.bind(this);

    if(FB.injected){
      return (
        <a onClick={this.click} href={this.props.href} style={finalStyle} id='FB_button_container'>
          {this.props.preventDefault && <span style={FB.invisible}></span>}
          <div className='fb-login-button'
          data-max-rows='1' data-size='large'
          data-button-type='continue_with' data-show-faces='false'
          data-auto-logout-link='false' data-use-continue-as='true'
          ></div>
        </a>
      );
    }
    throw new Error('No API key');
  }

  componentDidMount(){
    if(window.FB){
      const container = document.getElementById('FB_button_container');
      window.FB.XFBML.parse(container);
    }
  }
}

FB.propTypes = {
  style: PropTypes.object,
  href: PropTypes.string,
  onClick: PropTypes.func,
  preventDefault: PropTypes.bool
};

export default FB;


//onClick={context.FBsubmit}
